// Autogenerated file. Do not edit.

// ignore_for_file: camel_case_types
// ignore_for_file: non_constant_identifier_names

import '../handmade/json_model.dart';

class BingqueryContext extends JSONModel {
	static JSONModelFactory<BingqueryContext> factory = JSONModelFactory(create);

	String _type;
	String originalQuery;

	BingqueryContext.blank()
			: _type = '',
			  originalQuery = '',
			  super({});

	BingqueryContext.fromFields(
		this._type,
		this.originalQuery,
	) : super({});

	BingqueryContext.base(Map<String, dynamic> jsonData)
			: _type = JSONModel.getString(jsonData, '_type', defaultValue: ''),
			  originalQuery = JSONModel.getString(jsonData, 'originalQuery', defaultValue: ''),
			  super(jsonData);

	BingqueryContext(Map<String, dynamic> jsonData)
		: this.base(JSONModel.caseInsensitiveMap(jsonData));

	@override
	Map<String, dynamic> toJSON() {
		jsonData['_type'] = _type;
		jsonData['originalQuery'] = originalQuery;

		return jsonData;
	}

	@override
	int get hashCode {
		List<Object> o = [
		_type,
		originalQuery,
		];
		return modelHashList(o);
	}

	@override
	bool operator ==(Object? other) {
		if ((other is! BingqueryContext)) return false;
		BingqueryContext o = other;
		if (_type != o._type) return false;
		if (originalQuery != o.originalQuery) return false;

		return true;
	}

	BingqueryContext get clone {
		return BingqueryContext.blank()..copy(this);
	}

	@override
	void copy(covariant BingqueryContext o) {
		super.copy(o);
		_type = o._type;
		originalQuery = o.originalQuery;
	}


	@override
	int compareTo(other) {
		if (other is! BingqueryContext) { return toString().compareTo(other.toString()); }
		int ret = 0;
		BingqueryContext o = other;
		if (ret == 0) { ret = _type.compareTo(o._type); }
		if (ret == 0) { ret = originalQuery.compareTo(o.originalQuery); }

		return ret;
	}

	static BingqueryContext create(Map<String, dynamic> jsonData) {
		return BingqueryContext(jsonData);
	}
}

class BingwebPagesvalueField extends JSONModel {
	static JSONModelFactory<BingwebPagesvalueField> factory = JSONModelFactory(create);

	String _type;
	String name;
	String url;

	BingwebPagesvalueField.blank()
			: _type = '',
			  name = '',
			  url = '',
			  super({});

	BingwebPagesvalueField.fromFields(
		this._type,
		this.name,
		this.url,
	) : super({});

	BingwebPagesvalueField.base(Map<String, dynamic> jsonData)
			: _type = JSONModel.getString(jsonData, '_type', defaultValue: ''),
			  name = JSONModel.getString(jsonData, 'name', defaultValue: ''),
			  url = JSONModel.getString(jsonData, 'url', defaultValue: ''),
			  super(jsonData);

	BingwebPagesvalueField(Map<String, dynamic> jsonData)
		: this.base(JSONModel.caseInsensitiveMap(jsonData));

	@override
	Map<String, dynamic> toJSON() {
		jsonData['_type'] = _type;
		jsonData['name'] = name;
		jsonData['url'] = url;

		return jsonData;
	}

	@override
	int get hashCode {
		List<Object> o = [
		_type,
		name,
		url,
		];
		return modelHashList(o);
	}

	@override
	bool operator ==(Object? other) {
		if ((other is! BingwebPagesvalueField)) return false;
		BingwebPagesvalueField o = other;
		if (_type != o._type) return false;
		if (name != o.name) return false;
		if (url != o.url) return false;

		return true;
	}

	BingwebPagesvalueField get clone {
		return BingwebPagesvalueField.blank()..copy(this);
	}

	@override
	void copy(covariant BingwebPagesvalueField o) {
		super.copy(o);
		_type = o._type;
		name = o.name;
		url = o.url;
	}


	@override
	int compareTo(other) {
		if (other is! BingwebPagesvalueField) { return toString().compareTo(other.toString()); }
		int ret = 0;
		BingwebPagesvalueField o = other;
		if (ret == 0) { ret = _type.compareTo(o._type); }
		if (ret == 0) { ret = name.compareTo(o.name); }
		if (ret == 0) { ret = url.compareTo(o.url); }

		return ret;
	}

	static BingwebPagesvalueField create(Map<String, dynamic> jsonData) {
		return BingwebPagesvalueField(jsonData);
	}
}

class BingrankingResponsemainlineitemsvalue extends JSONModel {
	static JSONModelFactory<BingrankingResponsemainlineitemsvalue> factory = JSONModelFactory(create);

	String _type;
	String id;

	BingrankingResponsemainlineitemsvalue.blank()
			: _type = '',
			  id = '',
			  super({});

	BingrankingResponsemainlineitemsvalue.fromFields(
		this._type,
		this.id,
	) : super({});

	BingrankingResponsemainlineitemsvalue.base(Map<String, dynamic> jsonData)
			: _type = JSONModel.getString(jsonData, '_type', defaultValue: ''),
			  id = JSONModel.getString(jsonData, 'id', defaultValue: ''),
			  super(jsonData);

	BingrankingResponsemainlineitemsvalue(Map<String, dynamic> jsonData)
		: this.base(JSONModel.caseInsensitiveMap(jsonData));

	@override
	Map<String, dynamic> toJSON() {
		jsonData['_type'] = _type;
		jsonData['id'] = id;

		return jsonData;
	}

	@override
	int get hashCode {
		List<Object> o = [
		_type,
		id,
		];
		return modelHashList(o);
	}

	@override
	bool operator ==(Object? other) {
		if ((other is! BingrankingResponsemainlineitemsvalue)) return false;
		BingrankingResponsemainlineitemsvalue o = other;
		if (_type != o._type) return false;
		if (id != o.id) return false;

		return true;
	}

	BingrankingResponsemainlineitemsvalue get clone {
		return BingrankingResponsemainlineitemsvalue.blank()..copy(this);
	}

	@override
	void copy(covariant BingrankingResponsemainlineitemsvalue o) {
		super.copy(o);
		_type = o._type;
		id = o.id;
	}


	@override
	int compareTo(other) {
		if (other is! BingrankingResponsemainlineitemsvalue) { return toString().compareTo(other.toString()); }
		int ret = 0;
		BingrankingResponsemainlineitemsvalue o = other;
		if (ret == 0) { ret = _type.compareTo(o._type); }
		if (ret == 0) { ret = id.compareTo(o.id); }

		return ret;
	}

	static BingrankingResponsemainlineitemsvalue create(Map<String, dynamic> jsonData) {
		return BingrankingResponsemainlineitemsvalue(jsonData);
	}
}

class BingrankingResponsesidebaritems extends JSONModel {
	static JSONModelFactory<BingrankingResponsesidebaritems> factory = JSONModelFactory(create);

	String _type;
	String answerType;

	BingrankingResponsesidebaritems.blank()
			: _type = '',
			  answerType = '',
			  super({});

	BingrankingResponsesidebaritems.fromFields(
		this._type,
		this.answerType,
	) : super({});

	BingrankingResponsesidebaritems.base(Map<String, dynamic> jsonData)
			: _type = JSONModel.getString(jsonData, '_type', defaultValue: ''),
			  answerType = JSONModel.getString(jsonData, 'answerType', defaultValue: ''),
			  super(jsonData);

	BingrankingResponsesidebaritems(Map<String, dynamic> jsonData)
		: this.base(JSONModel.caseInsensitiveMap(jsonData));

	@override
	Map<String, dynamic> toJSON() {
		jsonData['_type'] = _type;
		jsonData['answerType'] = answerType;

		return jsonData;
	}

	@override
	int get hashCode {
		List<Object> o = [
		_type,
		answerType,
		];
		return modelHashList(o);
	}

	@override
	bool operator ==(Object? other) {
		if ((other is! BingrankingResponsesidebaritems)) return false;
		BingrankingResponsesidebaritems o = other;
		if (_type != o._type) return false;
		if (answerType != o.answerType) return false;

		return true;
	}

	BingrankingResponsesidebaritems get clone {
		return BingrankingResponsesidebaritems.blank()..copy(this);
	}

	@override
	void copy(covariant BingrankingResponsesidebaritems o) {
		super.copy(o);
		_type = o._type;
		answerType = o.answerType;
	}


	@override
	int compareTo(other) {
		if (other is! BingrankingResponsesidebaritems) { return toString().compareTo(other.toString()); }
		int ret = 0;
		BingrankingResponsesidebaritems o = other;
		if (ret == 0) { ret = _type.compareTo(o._type); }
		if (ret == 0) { ret = answerType.compareTo(o.answerType); }

		return ret;
	}

	static BingrankingResponsesidebaritems create(Map<String, dynamic> jsonData) {
		return BingrankingResponsesidebaritems(jsonData);
	}
}

class Bing extends JSONModel {
	static JSONModelFactory<Bing> factory = JSONModelFactory(create);

	String _type;
	BingqueryContext queryContext;
	BingwebPages webPages;
	BingrankingResponse rankingResponse;

	Bing.blank()
			: _type = '',
			  queryContext = BingqueryContext.blank(),
			  webPages = BingwebPages.blank(),
			  rankingResponse = BingrankingResponse.blank(),
			  super({});

	Bing.fromFields(
		this._type,
		this.queryContext,
		this.webPages,
		this.rankingResponse,
	) : super({});

	Bing.base(Map<String, dynamic> jsonData)
			: _type = JSONModel.getString(jsonData, '_type', defaultValue: ''),
			  queryContext = BingqueryContext(JSONModel.getMap(jsonData, 'queryContext')),
			  webPages = BingwebPages(JSONModel.getMap(jsonData, 'webPages')),
			  rankingResponse = BingrankingResponse(JSONModel.getMap(jsonData, 'rankingResponse')),
			  super(jsonData);

	Bing(Map<String, dynamic> jsonData)
		: this.base(JSONModel.caseInsensitiveMap(jsonData));

	@override
	Map<String, dynamic> toJSON() {
		jsonData['_type'] = _type;
		jsonData['queryContext'] = queryContext.toJSON();
		jsonData['webPages'] = webPages.toJSON();
		jsonData['rankingResponse'] = rankingResponse.toJSON();

		return jsonData;
	}

	@override
	int get hashCode {
		List<Object> o = [
		_type,
			queryContext,
			webPages,
			rankingResponse,
		];
		return modelHashList(o);
	}

	@override
	bool operator ==(Object? other) {
		if ((other is! Bing)) return false;
		Bing o = other;
		if (_type != o._type) return false;
		if (queryContext != o.queryContext) return false;
		if (webPages != o.webPages) return false;
		if (rankingResponse != o.rankingResponse) return false;

		return true;
	}

	Bing get clone {
		return Bing.blank()..copy(this);
	}

	@override
	void copy(covariant Bing o) {
		super.copy(o);
		_type = o._type;
		queryContext.copy(o.queryContext);
		webPages.copy(o.webPages);
		rankingResponse.copy(o.rankingResponse);
	}


	@override
	int compareTo(other) {
		if (other is! Bing) { return toString().compareTo(other.toString()); }
		int ret = 0;
		Bing o = other;
		if (ret == 0) { ret = _type.compareTo(o._type); }
		if (ret == 0) { ret = queryContext.compareTo(o.queryContext); }
		if (ret == 0) { ret = webPages.compareTo(o.webPages); }
		if (ret == 0) { ret = rankingResponse.compareTo(o.rankingResponse); }

		return ret;
	}

	static Bing create(Map<String, dynamic> jsonData) {
		return Bing(jsonData);
	}
}

class BingwebPages extends JSONModel {
	static JSONModelFactory<BingwebPages> factory = JSONModelFactory(create);

	String _type;
	String webSearchUrl;
	int totalEstimatedMatches;
	List<BingwebPagesvalue> value;

	BingwebPages.blank()
			: _type = '',
			  webSearchUrl = '',
			  totalEstimatedMatches = 0,
			  value = [],
			  super({});

	BingwebPages.fromFields(
		this._type,
		this.webSearchUrl,
		this.totalEstimatedMatches,
		this.value,
	) : super({});

	BingwebPages.base(Map<String, dynamic> jsonData)
			: _type = JSONModel.getString(jsonData, '_type', defaultValue: ''),
			  webSearchUrl = JSONModel.getString(jsonData, 'webSearchUrl', defaultValue: ''),
			  totalEstimatedMatches = JSONModel.getint(jsonData, 'totalEstimatedMatches', defaultValue: 0),
			  value = JSONModel.getList<BingwebPagesvalue>(jsonData, 'value',
(dynamic o) => o is Map ?
BingwebPagesvalue(JSONModel.mapMap(o)) : BingwebPagesvalue.blank(),),
			  super(jsonData);

	BingwebPages(Map<String, dynamic> jsonData)
		: this.base(JSONModel.caseInsensitiveMap(jsonData));

	@override
	Map<String, dynamic> toJSON() {
		jsonData['_type'] = _type;
		jsonData['webSearchUrl'] = webSearchUrl;
		jsonData['totalEstimatedMatches'] = totalEstimatedMatches;
		jsonData['value'] = JSONModel.jsonItem(value);

		return jsonData;
	}

	@override
	int get hashCode {
		List<Object> o = [
		_type,
		webSearchUrl,
		totalEstimatedMatches,
			modelHashList(value),
		];
		return modelHashList(o);
	}

	@override
	bool operator ==(Object? other) {
		if ((other is! BingwebPages)) return false;
		BingwebPages o = other;
		if (_type != o._type) return false;
		if (webSearchUrl != o.webSearchUrl) return false;
		if (totalEstimatedMatches != o.totalEstimatedMatches) return false;
		if (!modelListEquals(value, o.value)) return false;

		return true;
	}

	BingwebPages get clone {
		return BingwebPages.blank()..copy(this);
	}

	@override
	void copy(covariant BingwebPages o) {
		super.copy(o);
		_type = o._type;
		webSearchUrl = o.webSearchUrl;
		totalEstimatedMatches = o.totalEstimatedMatches;
		value = o.value.map((e) => e.clone).toList();
	}


	@override
	int compareTo(other) {
		if (other is! BingwebPages) { return toString().compareTo(other.toString()); }
		int ret = 0;
		BingwebPages o = other;
		if (ret == 0) { ret = _type.compareTo(o._type); }
		if (ret == 0) { ret = webSearchUrl.compareTo(o.webSearchUrl); }
		if (ret == 0) { ret = totalEstimatedMatches.compareTo(o.totalEstimatedMatches); }
		if (ret == 0) { ret = modelListCompareTo(value, o.value); }

		return ret;
	}

	static BingwebPages create(Map<String, dynamic> jsonData) {
		return BingwebPages(jsonData);
	}
}

class BingwebPagesvalue extends JSONModel {
	static JSONModelFactory<BingwebPagesvalue> factory = JSONModelFactory(create);

	String _type;
	String id;
	String name;
	String url;
	bool isFamilyFriendly;
	String displayUrl;
	String snippet;
	List<BingwebPagesvalueField> deepLinks;
	List<BingwebPagesvaluecontractualRules> contractualRules;
	String dateLastCrawled;
	String language;
	bool isNavigational;

	BingwebPagesvalue.blank()
			: _type = '',
			  id = '',
			  name = '',
			  url = '',
			  isFamilyFriendly = false,
			  displayUrl = '',
			  snippet = '',
			  deepLinks = [],
			  contractualRules = [],
			  dateLastCrawled = '',
			  language = '',
			  isNavigational = false,
			  super({});

	BingwebPagesvalue.fromFields(
		this._type,
		this.id,
		this.name,
		this.url,
		this.isFamilyFriendly,
		this.displayUrl,
		this.snippet,
		this.deepLinks,
		this.contractualRules,
		this.dateLastCrawled,
		this.language,
		this.isNavigational,
	) : super({});

	BingwebPagesvalue.base(Map<String, dynamic> jsonData)
			: _type = JSONModel.getString(jsonData, '_type', defaultValue: ''),
			  id = JSONModel.getString(jsonData, 'id', defaultValue: ''),
			  name = JSONModel.getString(jsonData, 'name', defaultValue: ''),
			  url = JSONModel.getString(jsonData, 'url', defaultValue: ''),
			  isFamilyFriendly = JSONModel.getbool(jsonData, 'isFamilyFriendly', defaultValue: false),
			  displayUrl = JSONModel.getString(jsonData, 'displayUrl', defaultValue: ''),
			  snippet = JSONModel.getString(jsonData, 'snippet', defaultValue: ''),
			  deepLinks = JSONModel.getList<BingwebPagesvalueField>(jsonData, 'deepLinks',
(dynamic o) => o is Map ?
BingwebPagesvalueField(JSONModel.mapMap(o)) : BingwebPagesvalueField.blank(),),
			  contractualRules = JSONModel.getList<BingwebPagesvaluecontractualRules>(jsonData, 'contractualRules',
(dynamic o) => o is Map ?
BingwebPagesvaluecontractualRules(JSONModel.mapMap(o)) : BingwebPagesvaluecontractualRules.blank(),),
			  dateLastCrawled = JSONModel.getString(jsonData, 'dateLastCrawled', defaultValue: ''),
			  language = JSONModel.getString(jsonData, 'language', defaultValue: ''),
			  isNavigational = JSONModel.getbool(jsonData, 'isNavigational', defaultValue: false),
			  super(jsonData);

	BingwebPagesvalue(Map<String, dynamic> jsonData)
		: this.base(JSONModel.caseInsensitiveMap(jsonData));

	@override
	Map<String, dynamic> toJSON() {
		jsonData['_type'] = _type;
		jsonData['id'] = id;
		jsonData['name'] = name;
		jsonData['url'] = url;
		jsonData['isFamilyFriendly'] = isFamilyFriendly;
		jsonData['displayUrl'] = displayUrl;
		jsonData['snippet'] = snippet;
		jsonData['deepLinks'] = JSONModel.jsonItem(deepLinks);
		jsonData['contractualRules'] = JSONModel.jsonItem(contractualRules);
		jsonData['dateLastCrawled'] = dateLastCrawled;
		jsonData['language'] = language;
		jsonData['isNavigational'] = isNavigational;

		return jsonData;
	}

	@override
	int get hashCode {
		List<Object> o = [
		_type,
		id,
		name,
		url,
		isFamilyFriendly,
		displayUrl,
		snippet,
			modelHashList(deepLinks),
			modelHashList(contractualRules),
		dateLastCrawled,
		language,
		isNavigational,
		];
		return modelHashList(o);
	}

	@override
	bool operator ==(Object? other) {
		if ((other is! BingwebPagesvalue)) return false;
		BingwebPagesvalue o = other;
		if (_type != o._type) return false;
		if (id != o.id) return false;
		if (name != o.name) return false;
		if (url != o.url) return false;
		if (isFamilyFriendly != o.isFamilyFriendly) return false;
		if (displayUrl != o.displayUrl) return false;
		if (snippet != o.snippet) return false;
		if (!modelListEquals(deepLinks, o.deepLinks)) return false;
		if (!modelListEquals(contractualRules, o.contractualRules)) return false;
		if (dateLastCrawled != o.dateLastCrawled) return false;
		if (language != o.language) return false;
		if (isNavigational != o.isNavigational) return false;

		return true;
	}

	BingwebPagesvalue get clone {
		return BingwebPagesvalue.blank()..copy(this);
	}

	@override
	void copy(covariant BingwebPagesvalue o) {
		super.copy(o);
		_type = o._type;
		id = o.id;
		name = o.name;
		url = o.url;
		isFamilyFriendly = o.isFamilyFriendly;
		displayUrl = o.displayUrl;
		snippet = o.snippet;
		deepLinks = o.deepLinks.map((e) => e.clone).toList();
		contractualRules = o.contractualRules.map((e) => e.clone).toList();
		dateLastCrawled = o.dateLastCrawled;
		language = o.language;
		isNavigational = o.isNavigational;
	}


	@override
	int compareTo(other) {
		if (other is! BingwebPagesvalue) { return toString().compareTo(other.toString()); }
		int ret = 0;
		BingwebPagesvalue o = other;
		if (ret == 0) { ret = _type.compareTo(o._type); }
		if (ret == 0) { ret = id.compareTo(o.id); }
		if (ret == 0) { ret = name.compareTo(o.name); }
		if (ret == 0) { ret = url.compareTo(o.url); }
		if (ret == 0) { ret = isFamilyFriendly.compareTo(o.isFamilyFriendly); }
		if (ret == 0) { ret = displayUrl.compareTo(o.displayUrl); }
		if (ret == 0) { ret = snippet.compareTo(o.snippet); }
		if (ret == 0) { ret = modelListCompareTo(deepLinks, o.deepLinks); }
		if (ret == 0) { ret = modelListCompareTo(contractualRules, o.contractualRules); }
		if (ret == 0) { ret = dateLastCrawled.compareTo(o.dateLastCrawled); }
		if (ret == 0) { ret = language.compareTo(o.language); }
		if (ret == 0) { ret = isNavigational.compareTo(o.isNavigational); }

		return ret;
	}

	static BingwebPagesvalue create(Map<String, dynamic> jsonData) {
		return BingwebPagesvalue(jsonData);
	}
}

class BingwebPagesvaluecontractualRules extends JSONModel {
	static JSONModelFactory<BingwebPagesvaluecontractualRules> factory = JSONModelFactory(create);

	String _type;
	String targetPropertyName;
	int targetPropertyIndex;
	bool mustBeCloseToContent;
	BingwebPagesvalueField license;
	String licenseNotice;

	BingwebPagesvaluecontractualRules.blank()
			: _type = '',
			  targetPropertyName = '',
			  targetPropertyIndex = 0,
			  mustBeCloseToContent = false,
			  license = BingwebPagesvalueField.blank(),
			  licenseNotice = '',
			  super({});

	BingwebPagesvaluecontractualRules.fromFields(
		this._type,
		this.targetPropertyName,
		this.targetPropertyIndex,
		this.mustBeCloseToContent,
		this.license,
		this.licenseNotice,
	) : super({});

	BingwebPagesvaluecontractualRules.base(Map<String, dynamic> jsonData)
			: _type = JSONModel.getString(jsonData, '_type', defaultValue: ''),
			  targetPropertyName = JSONModel.getString(jsonData, 'targetPropertyName', defaultValue: ''),
			  targetPropertyIndex = JSONModel.getint(jsonData, 'targetPropertyIndex', defaultValue: 0),
			  mustBeCloseToContent = JSONModel.getbool(jsonData, 'mustBeCloseToContent', defaultValue: false),
			  license = BingwebPagesvalueField(JSONModel.getMap(jsonData, 'license')),
			  licenseNotice = JSONModel.getString(jsonData, 'licenseNotice', defaultValue: ''),
			  super(jsonData);

	BingwebPagesvaluecontractualRules(Map<String, dynamic> jsonData)
		: this.base(JSONModel.caseInsensitiveMap(jsonData));

	@override
	Map<String, dynamic> toJSON() {
		jsonData['_type'] = _type;
		jsonData['targetPropertyName'] = targetPropertyName;
		jsonData['targetPropertyIndex'] = targetPropertyIndex;
		jsonData['mustBeCloseToContent'] = mustBeCloseToContent;
		jsonData['license'] = license.toJSON();
		jsonData['licenseNotice'] = licenseNotice;

		return jsonData;
	}

	@override
	int get hashCode {
		List<Object> o = [
		_type,
		targetPropertyName,
		targetPropertyIndex,
		mustBeCloseToContent,
			license,
		licenseNotice,
		];
		return modelHashList(o);
	}

	@override
	bool operator ==(Object? other) {
		if ((other is! BingwebPagesvaluecontractualRules)) return false;
		BingwebPagesvaluecontractualRules o = other;
		if (_type != o._type) return false;
		if (targetPropertyName != o.targetPropertyName) return false;
		if (targetPropertyIndex != o.targetPropertyIndex) return false;
		if (mustBeCloseToContent != o.mustBeCloseToContent) return false;
		if (license != o.license) return false;
		if (licenseNotice != o.licenseNotice) return false;

		return true;
	}

	BingwebPagesvaluecontractualRules get clone {
		return BingwebPagesvaluecontractualRules.blank()..copy(this);
	}

	@override
	void copy(covariant BingwebPagesvaluecontractualRules o) {
		super.copy(o);
		_type = o._type;
		targetPropertyName = o.targetPropertyName;
		targetPropertyIndex = o.targetPropertyIndex;
		mustBeCloseToContent = o.mustBeCloseToContent;
		license.copy(o.license);
		licenseNotice = o.licenseNotice;
	}


	@override
	int compareTo(other) {
		if (other is! BingwebPagesvaluecontractualRules) { return toString().compareTo(other.toString()); }
		int ret = 0;
		BingwebPagesvaluecontractualRules o = other;
		if (ret == 0) { ret = _type.compareTo(o._type); }
		if (ret == 0) { ret = targetPropertyName.compareTo(o.targetPropertyName); }
		if (ret == 0) { ret = targetPropertyIndex.compareTo(o.targetPropertyIndex); }
		if (ret == 0) { ret = mustBeCloseToContent.compareTo(o.mustBeCloseToContent); }
		if (ret == 0) { ret = license.compareTo(o.license); }
		if (ret == 0) { ret = licenseNotice.compareTo(o.licenseNotice); }

		return ret;
	}

	static BingwebPagesvaluecontractualRules create(Map<String, dynamic> jsonData) {
		return BingwebPagesvaluecontractualRules(jsonData);
	}
}

class BingrankingResponse extends JSONModel {
	static JSONModelFactory<BingrankingResponse> factory = JSONModelFactory(create);

	String _type;
	BingrankingResponsemainline mainline;
	BingrankingResponsesidebar sidebar;

	BingrankingResponse.blank()
			: _type = '',
			  mainline = BingrankingResponsemainline.blank(),
			  sidebar = BingrankingResponsesidebar.blank(),
			  super({});

	BingrankingResponse.fromFields(
		this._type,
		this.mainline,
		this.sidebar,
	) : super({});

	BingrankingResponse.base(Map<String, dynamic> jsonData)
			: _type = JSONModel.getString(jsonData, '_type', defaultValue: ''),
			  mainline = BingrankingResponsemainline(JSONModel.getMap(jsonData, 'mainline')),
			  sidebar = BingrankingResponsesidebar(JSONModel.getMap(jsonData, 'sidebar')),
			  super(jsonData);

	BingrankingResponse(Map<String, dynamic> jsonData)
		: this.base(JSONModel.caseInsensitiveMap(jsonData));

	@override
	Map<String, dynamic> toJSON() {
		jsonData['_type'] = _type;
		jsonData['mainline'] = mainline.toJSON();
		jsonData['sidebar'] = sidebar.toJSON();

		return jsonData;
	}

	@override
	int get hashCode {
		List<Object> o = [
		_type,
			mainline,
			sidebar,
		];
		return modelHashList(o);
	}

	@override
	bool operator ==(Object? other) {
		if ((other is! BingrankingResponse)) return false;
		BingrankingResponse o = other;
		if (_type != o._type) return false;
		if (mainline != o.mainline) return false;
		if (sidebar != o.sidebar) return false;

		return true;
	}

	BingrankingResponse get clone {
		return BingrankingResponse.blank()..copy(this);
	}

	@override
	void copy(covariant BingrankingResponse o) {
		super.copy(o);
		_type = o._type;
		mainline.copy(o.mainline);
		sidebar.copy(o.sidebar);
	}


	@override
	int compareTo(other) {
		if (other is! BingrankingResponse) { return toString().compareTo(other.toString()); }
		int ret = 0;
		BingrankingResponse o = other;
		if (ret == 0) { ret = _type.compareTo(o._type); }
		if (ret == 0) { ret = mainline.compareTo(o.mainline); }
		if (ret == 0) { ret = sidebar.compareTo(o.sidebar); }

		return ret;
	}

	static BingrankingResponse create(Map<String, dynamic> jsonData) {
		return BingrankingResponse(jsonData);
	}
}

class BingrankingResponsemainline extends JSONModel {
	static JSONModelFactory<BingrankingResponsemainline> factory = JSONModelFactory(create);

	String _type;
	List<BingrankingResponsemainlineitems> items;

	BingrankingResponsemainline.blank()
			: _type = '',
			  items = [],
			  super({});

	BingrankingResponsemainline.fromFields(
		this._type,
		this.items,
	) : super({});

	BingrankingResponsemainline.base(Map<String, dynamic> jsonData)
			: _type = JSONModel.getString(jsonData, '_type', defaultValue: ''),
			  items = JSONModel.getList<BingrankingResponsemainlineitems>(jsonData, 'items',
(dynamic o) => o is Map ?
BingrankingResponsemainlineitems(JSONModel.mapMap(o)) : BingrankingResponsemainlineitems.blank(),),
			  super(jsonData);

	BingrankingResponsemainline(Map<String, dynamic> jsonData)
		: this.base(JSONModel.caseInsensitiveMap(jsonData));

	@override
	Map<String, dynamic> toJSON() {
		jsonData['_type'] = _type;
		jsonData['items'] = JSONModel.jsonItem(items);

		return jsonData;
	}

	@override
	int get hashCode {
		List<Object> o = [
		_type,
			modelHashList(items),
		];
		return modelHashList(o);
	}

	@override
	bool operator ==(Object? other) {
		if ((other is! BingrankingResponsemainline)) return false;
		BingrankingResponsemainline o = other;
		if (_type != o._type) return false;
		if (!modelListEquals(items, o.items)) return false;

		return true;
	}

	BingrankingResponsemainline get clone {
		return BingrankingResponsemainline.blank()..copy(this);
	}

	@override
	void copy(covariant BingrankingResponsemainline o) {
		super.copy(o);
		_type = o._type;
		items = o.items.map((e) => e.clone).toList();
	}


	@override
	int compareTo(other) {
		if (other is! BingrankingResponsemainline) { return toString().compareTo(other.toString()); }
		int ret = 0;
		BingrankingResponsemainline o = other;
		if (ret == 0) { ret = _type.compareTo(o._type); }
		if (ret == 0) { ret = modelListCompareTo(items, o.items); }

		return ret;
	}

	static BingrankingResponsemainline create(Map<String, dynamic> jsonData) {
		return BingrankingResponsemainline(jsonData);
	}
}

class BingrankingResponsemainlineitems extends JSONModel {
	static JSONModelFactory<BingrankingResponsemainlineitems> factory = JSONModelFactory(create);

	String _type;
	String answerType;
	int resultIndex;
	BingrankingResponsemainlineitemsvalue value;

	BingrankingResponsemainlineitems.blank()
			: _type = '',
			  answerType = '',
			  resultIndex = 0,
			  value = BingrankingResponsemainlineitemsvalue.blank(),
			  super({});

	BingrankingResponsemainlineitems.fromFields(
		this._type,
		this.answerType,
		this.resultIndex,
		this.value,
	) : super({});

	BingrankingResponsemainlineitems.base(Map<String, dynamic> jsonData)
			: _type = JSONModel.getString(jsonData, '_type', defaultValue: ''),
			  answerType = JSONModel.getString(jsonData, 'answerType', defaultValue: ''),
			  resultIndex = JSONModel.getint(jsonData, 'resultIndex', defaultValue: 0),
			  value = BingrankingResponsemainlineitemsvalue(JSONModel.getMap(jsonData, 'value')),
			  super(jsonData);

	BingrankingResponsemainlineitems(Map<String, dynamic> jsonData)
		: this.base(JSONModel.caseInsensitiveMap(jsonData));

	@override
	Map<String, dynamic> toJSON() {
		jsonData['_type'] = _type;
		jsonData['answerType'] = answerType;
		jsonData['resultIndex'] = resultIndex;
		jsonData['value'] = value.toJSON();

		return jsonData;
	}

	@override
	int get hashCode {
		List<Object> o = [
		_type,
		answerType,
		resultIndex,
			value,
		];
		return modelHashList(o);
	}

	@override
	bool operator ==(Object? other) {
		if ((other is! BingrankingResponsemainlineitems)) return false;
		BingrankingResponsemainlineitems o = other;
		if (_type != o._type) return false;
		if (answerType != o.answerType) return false;
		if (resultIndex != o.resultIndex) return false;
		if (value != o.value) return false;

		return true;
	}

	BingrankingResponsemainlineitems get clone {
		return BingrankingResponsemainlineitems.blank()..copy(this);
	}

	@override
	void copy(covariant BingrankingResponsemainlineitems o) {
		super.copy(o);
		_type = o._type;
		answerType = o.answerType;
		resultIndex = o.resultIndex;
		value.copy(o.value);
	}


	@override
	int compareTo(other) {
		if (other is! BingrankingResponsemainlineitems) { return toString().compareTo(other.toString()); }
		int ret = 0;
		BingrankingResponsemainlineitems o = other;
		if (ret == 0) { ret = _type.compareTo(o._type); }
		if (ret == 0) { ret = answerType.compareTo(o.answerType); }
		if (ret == 0) { ret = resultIndex.compareTo(o.resultIndex); }
		if (ret == 0) { ret = value.compareTo(o.value); }

		return ret;
	}

	static BingrankingResponsemainlineitems create(Map<String, dynamic> jsonData) {
		return BingrankingResponsemainlineitems(jsonData);
	}
}

class BingrankingResponsesidebar extends JSONModel {
	static JSONModelFactory<BingrankingResponsesidebar> factory = JSONModelFactory(create);

	String _type;
	List<BingrankingResponsesidebaritems> items;

	BingrankingResponsesidebar.blank()
			: _type = '',
			  items = [],
			  super({});

	BingrankingResponsesidebar.fromFields(
		this._type,
		this.items,
	) : super({});

	BingrankingResponsesidebar.base(Map<String, dynamic> jsonData)
			: _type = JSONModel.getString(jsonData, '_type', defaultValue: ''),
			  items = JSONModel.getList<BingrankingResponsesidebaritems>(jsonData, 'items',
(dynamic o) => o is Map ?
BingrankingResponsesidebaritems(JSONModel.mapMap(o)) : BingrankingResponsesidebaritems.blank(),),
			  super(jsonData);

	BingrankingResponsesidebar(Map<String, dynamic> jsonData)
		: this.base(JSONModel.caseInsensitiveMap(jsonData));

	@override
	Map<String, dynamic> toJSON() {
		jsonData['_type'] = _type;
		jsonData['items'] = JSONModel.jsonItem(items);

		return jsonData;
	}

	@override
	int get hashCode {
		List<Object> o = [
		_type,
			modelHashList(items),
		];
		return modelHashList(o);
	}

	@override
	bool operator ==(Object? other) {
		if ((other is! BingrankingResponsesidebar)) return false;
		BingrankingResponsesidebar o = other;
		if (_type != o._type) return false;
		if (!modelListEquals(items, o.items)) return false;

		return true;
	}

	BingrankingResponsesidebar get clone {
		return BingrankingResponsesidebar.blank()..copy(this);
	}

	@override
	void copy(covariant BingrankingResponsesidebar o) {
		super.copy(o);
		_type = o._type;
		items = o.items.map((e) => e.clone).toList();
	}


	@override
	int compareTo(other) {
		if (other is! BingrankingResponsesidebar) { return toString().compareTo(other.toString()); }
		int ret = 0;
		BingrankingResponsesidebar o = other;
		if (ret == 0) { ret = _type.compareTo(o._type); }
		if (ret == 0) { ret = modelListCompareTo(items, o.items); }

		return ret;
	}

	static BingrankingResponsesidebar create(Map<String, dynamic> jsonData) {
		return BingrankingResponsesidebar(jsonData);
	}
}
